import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import { Observable } from 'rxjs/Observable';
import { Channel } from './Channel';
import { WebChannel } from './service/WebChannel';
export declare const CONNECT_TIMEOUT = 6000;
/**
 * Service class responsible to establish connections between peers via
 * `WebSocket`.
 */
export declare class WebSocketBuilder {
    static listen(): BehaviorSubject<string>;
    static newIncomingSocket(wc: WebChannel, ws: WebSocket, senderId: number): void;
    private wc;
    private channelsSubject;
    constructor(wc: WebChannel);
    readonly onChannel: Observable<Channel>;
    /**
     * Establish `WebSocket` with a server if `id` is not specified,
     * otherwise return an opened `Channel` with a peer identified by the
     * specified `id`.
     *
     * @param url Server URL
     * @param id  Peer id
     */
    connect(url: string, id?: number): Promise<WebSocket | Channel>;
}
