/**
 * Equals to true in any browser.
 */
export declare const isBrowser: boolean;
export declare function isOnline(): boolean;
export declare function isVisible(): boolean;
/**
 * Check whether the string is a valid URL.
 */
export declare function isURL(str: string): boolean;
/**
 * Generate random key which will be used to join the network.
 */
export declare function generateKey(): string;
export declare function randNumbers(length?: number): number[] | Uint32Array;
export declare function equal(array1: number[], array2: number[]): boolean;
export declare const MAX_KEY_LENGTH = 512;
export interface ILog {
    webgroup: (msg: string, ...rest: any[]) => void;
    signalingState: (msg: string, id: number) => void;
    webGroupState: (msg: string, id: number) => void;
    webrtc: (msg: string, ...rest: any[]) => void;
    channel: (msg: string, ...rest: any[]) => void;
    topology: (msg: string, ...rest: any[]) => void;
    signaling: (msg: string, ...rest: any[]) => void;
    channelBuilder: (msg: string, ...rest: any[]) => void;
    debug: (msg: string, ...rest: any[]) => void;
}
declare const log: ILog;
export declare enum LogLevel {
    DEBUG = 0,
    WEB_GROUP = 1,
    WEBRTC = 2,
    CHANNEL = 3,
    TOPOLOGY = 4,
    SIGNALING = 5,
    CHANNEL_BUILDER = 6,
}
export declare let logLevels: LogLevel[];
export declare function setLogLevel(levels: LogLevel[]): void;
export { log };
