var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Subject } from 'rxjs/Subject';
import { log } from '../misc/Util';
import { channelBuilder as proto } from '../proto';
import { CONNECT_TIMEOUT as WEBSOCKET_TIMEOUT, WebSocketBuilder } from '../WebSocketBuilder';
import { Service } from './Service';
import { CONNECT_TIMEOUT as WEBRTC_TIMEOUT, WebRTCBuilder } from './WebRTCBuilder';
/**
 * Service id.
 */
var ID = 100;
var ME = {
    wsUrl: '',
    isWrtcSupport: false,
};
var CONNECT_TIMEOUT = Math.max(WEBRTC_TIMEOUT, WEBSOCKET_TIMEOUT) + 3000;
var DEFAULT_PINGPONG_TIMEOUT = 700;
var MAX_PINGPONG_TIMEOUT = 3000;
var ping = Service.encodeServiceMessage(ID, proto.Message.encode(proto.Message.create({ ping: true })).finish());
var pong = Service.encodeServiceMessage(ID, proto.Message.encode(proto.Message.create({ pong: true })).finish());
var requestMsg;
var responseMsg;
/**
 * It is responsible to build a channel between two peers with a help of `WebSocketBuilder` and `WebRTCBuilder`.
 * Its algorithm determine which channel (socket or dataChannel) should be created
 * based on the services availability and peers' preferences.
 */
var ChannelBuilder = /** @class */ (function (_super) {
    __extends(ChannelBuilder, _super);
    function ChannelBuilder(wc) {
        var _this = _super.call(this, ID, proto.Message, wc.serviceMessageSubject) || this;
        _this.wc = wc;
        _this.connectionRequests = new Map();
        _this.pingPongRequests = new Map();
        _this.channelsSubject = new Subject();
        _this.pingPongTimeout = DEFAULT_PINGPONG_TIMEOUT;
        _this.pingPongDates = new Map();
        // Listen on Channels as RTCDataChannels if WebRTC is supported
        ME.isWrtcSupport = WebRTCBuilder.isSupported;
        if (ME.isWrtcSupport) {
            wc.webRTCBuilder.onChannelFromWebChannel()
                .subscribe(function (ch) { return _this.handleChannel(ch); });
        }
        // Listen on Channels as WebSockets if the peer is listening on WebSockets
        WebSocketBuilder.listen().subscribe(function (url) {
            ME.wsUrl = url;
            if (url) {
                wc.webSocketBuilder.onChannel.subscribe(function (ch) { return _this.handleChannel(ch); });
            }
            // Update preconstructed messages (for performance only)
            var content = { wsUrl: url, isWrtcSupport: ME.isWrtcSupport };
            requestMsg = _super.prototype.encode.call(_this, { request: content });
            responseMsg = _super.prototype.encode.call(_this, { response: content });
        });
        // Subscribe to WebChannel internal messages
        _this.onServiceMessage.subscribe(function (msg) { return _this.treatServiceMessage(msg); });
        return _this;
    }
    Object.defineProperty(ChannelBuilder.prototype, "onChannel", {
        get: function () {
            return this.channelsSubject.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Establish a `Channel` with the peer identified by `id`.
     */
    ChannelBuilder.prototype.connectTo = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var channel;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.isResponding(id)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                var timer = setTimeout(function () {
                                    _this.connectionRequests.delete(id);
                                    reject(new Error('ChannelBuilder timeout'));
                                }, CONNECT_TIMEOUT);
                                _this.connectionRequests.set(id, {
                                    resolve: function (ch) {
                                        _this.connectionRequests.delete(id);
                                        clearTimeout(timer);
                                        resolve(ch);
                                    }, reject: function (err) {
                                        _this.connectionRequests.delete(id);
                                        reject(err);
                                    },
                                });
                                _this.wc.sendToProxy({ recipientId: id, content: requestMsg });
                            })];
                    case 2:
                        channel = _a.sent();
                        return [2 /*return*/, channel];
                }
            });
        });
    };
    ChannelBuilder.prototype.isResponding = function (id) {
        var _this = this;
        var ppRequest = this.pingPongRequests.get(id);
        if (ppRequest) {
            return ppRequest.promise;
        }
        else {
            this.wc.sendToProxy({ recipientId: id, content: ping });
            var promise_1 = new Promise(function (resolve, reject) {
                var timer = setTimeout(function () {
                    _this.pingPongRequests.delete(id);
                    reject(new Error('pingpong'));
                }, _this.pingPongTimeout);
                _this.pingPongRequests.set(id, {
                    promise: promise_1,
                    resolve: function () {
                        _this.pingPongRequests.delete(id);
                        clearTimeout(timer);
                        resolve();
                    },
                });
                _this.pingPongDates.set(id, global.Date.now());
            });
            return promise_1;
        }
    };
    ChannelBuilder.prototype.handleChannel = function (ch) {
        var pendReq = this.connectionRequests.get(ch.id);
        if (pendReq) {
            pendReq.resolve(ch);
        }
        else {
            this.channelsSubject.next(ch);
        }
    };
    ChannelBuilder.prototype.treatServiceMessage = function (_a) {
        var _this = this;
        var senderId = _a.senderId, msg = _a.msg;
        switch (msg.type) {
            case 'ping': {
                this.wc.sendToProxy({ recipientId: senderId, content: pong });
                break;
            }
            case 'pong': {
                var ppRequest = this.pingPongRequests.get(senderId);
                var date = global.Date.now();
                var requestDate = this.pingPongDates.get(senderId);
                if (ppRequest) {
                    log.channelBuilder('Ping/Pong latency is: ' + (date - requestDate));
                    ppRequest.resolve();
                }
                else {
                    log.channelBuilder('INCREASING Ping/Pong timeout, as current latency is: '
                        + (date - requestDate) + ' new value: ', date - requestDate + 500);
                    this.pingPongTimeout = global.Math.min(date - requestDate + 500, MAX_PINGPONG_TIMEOUT);
                }
                break;
            }
            case 'failed': {
                console.warn('treatServiceMessage ERROR: ', msg.failed);
                var pr = this.connectionRequests.get(senderId);
                if (pr !== undefined) {
                    pr.reject(new Error(msg.failed));
                }
                break;
            }
            case 'request': {
                var _b = msg.request, wsUrl = _b.wsUrl, isWrtcSupport = _b.isWrtcSupport;
                // If remote peer is listening on WebSocket, connect to him
                if (wsUrl) {
                    this.wc.webSocketBuilder.connect(wsUrl, senderId)
                        .then(function (ch) { return _this.handleChannel(ch); })
                        .catch(function (reason) {
                        if (ME.wsUrl) {
                            // Ask him to connect to me via WebSocket
                            _this.wc.sendToProxy({ recipientId: senderId, content: responseMsg });
                        }
                        else {
                            // Send failed reason
                            _this.wc.sendToProxy({
                                recipientId: senderId,
                                content: _super.prototype.encode.call(_this, { failed: "Failed to establish a socket: " + reason }),
                            });
                        }
                    });
                    // If remote peer is able to connect over RTCDataChannel, verify first if I am listening on WebSocket
                }
                else if (isWrtcSupport) {
                    if (ME.wsUrl) {
                        // Ask him to connect to me via WebSocket
                        this.wc.sendToProxy({ recipientId: senderId, content: responseMsg });
                    }
                    else if (ME.isWrtcSupport) {
                        this.wc.webRTCBuilder.connectOverWebChannel(senderId)
                            .then(function (ch) { return _this.handleChannel(ch); })
                            .catch(function (err) {
                            // Send failed reason
                            _this.wc.sendToProxy({
                                recipientId: senderId,
                                content: _super.prototype.encode.call(_this, { failed: "Failed establish a data channel: " + err.message }),
                            });
                        });
                    }
                    else {
                        // Send failed reason
                        this.wc.sendToProxy({
                            recipientId: senderId,
                            content: _super.prototype.encode.call(this, { failed: 'No common connectors' }),
                        });
                    }
                    // If peer is not listening on WebSocket and is not able to connect over RTCDataChannel
                }
                else if (!wsUrl && !isWrtcSupport) {
                    if (ME.wsUrl) {
                        // Ask him to connect to me via WebSocket
                        this.wc.sendToProxy({ recipientId: senderId, content: responseMsg });
                    }
                    else {
                        // Send failed reason
                        this.wc.sendToProxy({
                            recipientId: senderId,
                            content: _super.prototype.encode.call(this, { failed: 'No common connectors' }),
                        });
                    }
                }
                break;
            }
            case 'response': {
                var wsUrl = msg.response.wsUrl;
                if (wsUrl) {
                    this.wc.webSocketBuilder.connect(wsUrl, senderId)
                        .then(function (ch) { return _this.handleChannel(ch); })
                        .catch(function (err) {
                        var request = _this.connectionRequests.get(senderId);
                        if (request) {
                            request.reject(new Error("Failed to establish a socket: " + err.message));
                        }
                    });
                }
                break;
            }
        }
    };
    return ChannelBuilder;
}(Service));
export { ChannelBuilder };
